# Copyright (c) 2012: Thiago Chaves de Oliveira Horta <shundread@gmail.com>
#
# Authors: Thiago Chaves de Oliveira Horta
#
# License: GPL v3 (see gpl-3.0.txt)

from entity import *
from brain import *
from graphics import *
from constant import *
from utils import *

class Actor(Entity):
    def __init__(self, sprite, brain, position, solid, speed):
        Entity.__init__(self, sprite, position, solid)
        self.speed = speed
        self.brain = brain
        self.brain.set_actor(self)

    def get_speed(self):
        return self.speed

    def update(self, game_data, dt):
        Entity.update(self, game_data, dt)
        self.brain.update(game_data, dt)

    def think(self, game_data, dt):
        self.brain.think(game_data, dt)

####

class Hero(Actor):
    def __init__(self, input_device, position):
        frames = load_sprite(join('data', 'dude.png'), (32, 32))
        animations = default_animation_map(frames)
        sprite = AnimatedSprite(animations)
        brain = InputControlledBrain(input_device)
        Actor.__init__(self, sprite, brain, position, True, SpeedNormal)

