# Copyright (c) 2012: Thiago Chaves de Oliveira Horta <shundread@gmail.com>
#
# Authors: Thiago Chaves de Oliveira Horta
#
# License: GPL v3 (see gpl-3.0.txt)

from constant import *
from utils import *

from pygame.rect import Rect

class Brain(object):
    def __init__(self):
        pass

    def set_actor(self, actor):
        self.actor = actor

    def get_actor(self):
        return self.actor

    def update(self, game_data, dt):
        pass

    def think(self, game_data, dt):
        pass

class InputControlledBrain(Brain):
    def __init__(self, input_device):
        Brain.__init__(self)
        self.input_device = input_device

    def think(self, game_data, dt):
        (dx, dy) = self.input_device.get_directional()
        level = game_data['level']
        actor = self.get_actor()
        rect = actor.get_rect()
        speed = actor.get_speed()
        next_rect = Rect((rect.left+dx*speed, rect.top+dy*speed), rect.size)
        if not level.solid_around(next_rect):
            actor.move((dx*speed, dy*speed))

