# Copyright (c) 2012: Thiago Chaves de Oliveira Horta <shundread@gmail.com>
#
# Authors: Thiago Chaves de Oliveira Horta
#
# License: GPL v3 (see gpl-3.0.txt)

class Timer(object):
    def __init__(self, count_to, callback_function, *callback_data):
        self.timer = count_to
        self.function = callback_function
        self.callback_data = callback_data

    def finished(self):
        return self.timer == 0

    def update(self, dt):
        if self.timer > 0:
            self.timer = max(0, self.timer - dt)
            if self.timer == 0:
                self.function(self.function_data)

class RepeatingTimer(Timer):
    def __init__(self, count_to, callback_function, *callback_data):
        Timer.__init__(self, count_to, callback_function, callback_data)
        self.reset_to = count_to

    def update(self, dt):
        Timer.update(self, dt)
        if self.finished():
           self.timer = self.reset_to 

