#!/usr/bin/env python

# Copyright (c) 2012: Thiago Chaves de Oliveira Horta <shundread@gmail.com>
#
# Authors: Thiago Chaves de Oliveira Horta
#
# License: GPL v3 (see gpl-3.0.txt)

from os.path import join

import pygame

from lib import *
from lib.constant import *
from lib.utils import *

def init():
    pygame.init()
    graphics.init()
    pygame.event.set_blocked(None)
    pygame.event.set_allowed([pygame.QUIT, pygame.KEYDOWN])

def main():
    init()
    clock = pygame.time.Clock()
    screen = pygame.display.get_surface()

    keyboard = inputs.Keyboard()
    lvl = level.Level1()

    hero = actor.Hero(keyboard, map_to_screen((1, 1)))

    game_data = {'level' : lvl}

    dt = 0
    while not pygame.event.get(pygame.QUIT):
        # Input update phase
        keyboard.update(pygame.event.get(pygame.KEYDOWN))

        # Thinking phase
        hero.think(game_data, dt)

        # Update phase
        hero.update(game_data, dt)

        # Drawing phase
        lvl.draw(screen, lvl.get_boundaries())
        lvl.highlight_around(screen, lvl.get_boundaries(), hero.get_rect())
        hero.draw(screen)
        pygame.display.flip()

        # End of loop
        dt = clock.tick(Fps)

if __name__=='__main__':
    main()

